-- tbalu1.vhd Version 1.1 by Dr. Jerry H. Tucker
-- Created  9/15/08     
LIBRARY IEEE;
USE work.all;
USE IEEE.Std_Logic_1164.all; 
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL; 
----------------------------------------------------------
--  ENTITY: TB - Test bench for alu1.VHD
--   NEEDS: alu1.vhd
----------------------------------------------------------
ENTITY TB IS
END ENTITY TB;

ARCHITECTURE TEST OF TB IS
    SIGNAL a, b, cin, cout, g, p: std_logic := '0';
    SIGNAL ainv, binv, less, r_and, r_or, r_add, r_less: std_logic := '0';
BEGIN
    less <= not less after 10 ns;
    cin  <= not cin after 20 ns;
    a    <= not a after 40 ns;
    b    <= not b after 80 ns;
    binv <= not binv after 160 ns;
    ainv <= not ainv when (binv'event and binv = '0');
    alu1_and: entity alu1 
       PORT MAP (a,b,ainv,binv,less,"00",cin,R_and);
    alu1_or: entity alu1 
       PORT MAP (a,b,ainv,binv,less,"01",cin,R_or);
    alu1_add: entity alu1 
       PORT MAP (a,b,ainv,binv,less,"10",cin,R_add,
                 cout,p,g);
    alu1_less: entity alu1 
       PORT MAP (a,b,ainv,binv,less,"11",cin,R_less,
                 cout,p,g);
    process
    begin
        wait on less, cin, a, b, binv; -- Wait for input to change
        wait for 9 ns;                 -- Let settle
        assert r_and = (a and b) report "AND error.";
        assert r_or  = (a or b) report "OR error.";
        assert r_add = ((a xor b) xor cin) report "ADD error.";
        assert (r_less = less) report "LESS error";
    end process;    
END ARCHITECTURE TEST;


